DP-FatMouse and Cheese(HDU 记忆化搜索)

FatMouse and Cheese

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 12342    Accepted Submission(s): 5224


Problem Description
FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move. 
 

Input
There are several test cases. Each test case consists of 

a line containing two integers between 1 and 100: n and k 
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on. 
The input ends with a pair of -1's. 
 

Output
For each test case output in a line the single integer giving the number of blocks of cheese collected. 
 

Sample Input
 
  
3 1 1 2 5 10 11 6 12 12 7 -1 -1
 

Sample Output
 
  
37  

解题须知:记忆化搜索 即 搜索+动态规划数组记录上一层计算结果,避免过多的重复计算 算法上依然是搜索的流程,但是搜索到的一些解用动态规划的那种思想和模式作一些保存;一般说来,动态规划总要遍历所有的状态,而搜索可以排除一些无效状态。更重要的是搜索还可以剪枝,可能剪去大量不必要的状态,因此在空间开销上往往比动态规划要低很多。

记忆化算法在求解的时候还是按着自顶向下的顺序,但是每求解一个状态,就将它的解保存下来,以后再次遇到这个状态的时候,就不必重新求解了

这种方法综合了搜索和动态规划两方面的优点,因而还是很有实用价值的。可以归纳为:记忆化搜索=搜索的形式+动态规划的思想

分析:本题的意思是老鼠从(0,0)位置可以往上下左右四个方向走,但每次走的位置的奶酪数必须必原来位置的奶酪数多,求老鼠最多能吃到的奶酪数。根据题意很容易想到,利用搜索的方式求出每种可能的情况老鼠能够吃到的奶酪,然后通过比较得出最大值,即为题解。这种解法理论上没有问题,但是这种解法重复搜索了奶酪位置,效率相对就比较低了,可以解决一些数据量不是很大的题目。就本题而言,此种解法时间会超限,所以本题采用了搜索加动态规划数组的方式,这就是所谓的记忆化搜索,每一次都记录下这种状态下的最优解,然后比较得出最后的结论。

import java.util.*;
public class HDU_FatMouse_and_Cheese {
	static int m,n,sum=0;
	static int[][] a=new int[200][200];       //记录每个点的奶酪
	static int[] dx= {-1,0,1,0};              //x方向的运动,左,右
	static int[] dy= {0,1,0,-1};              //y方向的运动,上,下
	static int[][] dp=new int[200][200];      //记录到达每个点能吃到的最多的奶酪
	public static int dfs(int x,int y) {
		int nx,ny;
		if(dp[x][y]==0) {
			int max=0,sum=0;
			for(int k=1;k<=m;k++) {
				for(int i=0;i<4;i++) {
					nx=x+dx[i]*m;
					ny=y+dy[i]*m;
					if(nx>=0&&nx<n&&ny>=0&&ny<n&&a[nx][ny]>a[x][y]) {
						sum=dfs(nx,ny);
						max=Math.max(sum,max);
					}
				}
			}
			dp[x][y]=max+a[x][y];
		}
		return dp[x][y];
	}
	public static void main(String[] args) {
		Scanner in=new Scanner(System.in);
		n=in.nextInt();
		m=in.nextInt();
		while(m!=-1&&n!=-1) {
			for(int i=0;i<n;i++) 
				for(int j=0;j<n;j++)
					a[i][j]=in.nextInt();
			System.out.println(dfs(0,0));
			m=in.nextInt();
			n=in.nextInt();
		}
	}
}

猜你喜欢

转载自blog.csdn.net/zw159357/article/details/79668507